/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	ScormItemList
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.xms.logsumup.scorm;

import java.io.Serializable;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;

import org.apache.xpath.XPathAPI;
import org.w3c.dom.Node;

/**
 * Scorm個別ログ教材構造リストクラス。<BR>
 * 個別ログメニューツリー表示からクリックされた以下のセクション/AUを
 * WBT個別ログに表示する順で、タイプ、UID、ノード名称をリストとして保持する。<BR>
 */
public class ScormItemList implements Serializable {

	/**
	 * 教材構造リスト
	 */
	private List itemInfoList = new ArrayList();

	/**
	 * コンストラクタ。<br>
	 * インスタンスを生成した時点でノードリストを生成し内部に保持する。<br>
	 * 
	 * @param scormDocument 教材構造を保持するクラス・オブジェクト。
	 * @param targetID リスト対象とするitemのルートitemのidentifier属性。
	 */
	public ScormItemList(ScormDocument scormDocument, String targetID) {
		// ノードのリストを作成（全てのＡｕタイプを含みます）
		try {
			List items = scormDocument.getDescendantItems(targetID);
			for ( int i = 0; i < items.size(); i++) {
				Node item = (Node)items.get(i);
				Map itemInfoMap = new HashMap();
				// ID
				Node itemIdNode = XPathAPI.selectSingleNode(
						item, "./@identifier");
				String itemId = itemIdNode.getNodeValue();
				itemInfoMap.put(ScormNodeConst.KEY_NODE_AU_ID, itemId);
				// 種別
				int itemType = scormDocument.getItemType(item);
				itemInfoMap.put(ScormNodeConst.KEY_NODE_MA_ID,
					new Integer(itemType));
				// タイトル
				Node titleTextNode = XPathAPI.selectSingleNode(
					item, "./title/text()");
				itemInfoMap.put(ScormNodeConst.KEY_NODE_TI_ID,
					titleTextNode.getNodeValue());
				// item情報をリストに追加
				itemInfoList.add(itemInfoMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * 保持している教材リストから指定位置のＡＵＩＤを返します。
	 * @param index
	 * @return 指定したリスト番号のＡＵＩＤ
	 */
	public String getAuID(int index) {
		Map tempMap = (Map)itemInfoList.get(index);
		return (String)tempMap.get(ScormNodeConst.KEY_NODE_AU_ID);
	}

	/**
	 * 保持しているノードリストから指定したノードの種別を戻す。
	 * @param index ノードリストから取得するノードのインデックス。
	 * @return 取得したノードの種別。STATUS_SまたはSTATUS_A。
	 * @see ScormNodeConst#ASSET_NODE
	 * @see ScormNodeConst#SCO_NODE
	 * @see ScormNodeConst#BLOCK_NODE
	 */
	public int getAuType(int index) {
		Map tempMap = (Map)itemInfoList.get(index);
		Integer auType = (Integer)tempMap.get(ScormNodeConst.KEY_NODE_MA_ID);
		return auType.intValue();
	}

	/**
	 * 保持しているノードリストから指定したノードのタイトルを戻す。
	 * @param index ノードリストから取得するノードのインデックス。
	 * @return 取得したノードのUID。
	 */
	public String getAuTitle(int index) {
		Map tempMap = (Map)itemInfoList.get(index);
		return (String)tempMap.get(ScormNodeConst.KEY_NODE_TI_ID);
	}

	/**
	 * 保持しているノードリストの要素数を戻す。
	 * @return 保持しているノードリストの要素数。
	 */
	public int getMaxRow() {
		return itemInfoList.size();
	}

}